package be.selckin.ws.util.java2php;

import be.selckin.ws.util.java2php.php.PhpService;
import be.selckin.ws.util.java2php.php.PhpType;
import com.google.common.collect.Lists;

import java.util.Collections;
import java.util.Comparator;
import java.util.List;

public class Utils {

    public static final Comparator<PhpService> SERVICE_COMPARATOR = new Comparator<PhpService>() {
        @Override
        public int compare(PhpService o1, PhpService o2) {
            return o1.getName().compareTo(o2.getName());
        }
    };
    public static final Comparator<PhpType> PHP_TYPE_COMPARATOR = new Comparator<PhpType>() {
        @Override
        public int compare(PhpType o1, PhpType o2) {
            return o1.getName().compareTo(o2.getName());
        }
    };

    public static <T> List<T> sort(Iterable<T> services, Comparator<T> comparator) {
        List<T> sorted = Lists.newArrayList(services);
        Collections.sort(sorted, comparator);
        return sorted;
    }
}
