package be.selckin.ws.util.java2php.php;

import com.google.common.base.Predicate;
import com.google.common.collect.Iterables;
import com.google.common.collect.Lists;

import javax.xml.namespace.QName;
import java.util.List;

public class PhpClass extends PhpType {

    private final List<PhpProperty> properties;

    public PhpClass(QName qName, String namespace, String name, List<PhpProperty> properties) {
        super(qName, namespace, name);
        this.properties = properties;
    }

    public List<PhpProperty> getProperties() {
        return properties;
    }

    public List<PhpProperty> getRequiredProperties() {
        return Lists.newArrayList(Iterables.filter(properties, new Predicate<PhpProperty>() {
            @Override
            public boolean apply(PhpProperty input) {
                return input.isRequired();
            }
        }));
    }
}


