package be.selckin.ws.util.java2php.php;

import javax.xml.namespace.QName;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

public class PhpService {
    private final QName qname;
    private final String namespace;
    private final String name;
    private final List<Operation> operations = new ArrayList<>();

    public PhpService(QName qname, String namespace, String name) {
        this.qname = qname;
        this.namespace = namespace;
        this.name = name;
    }

    public void addOperation(Operation operation) {
        operations.add(operation);
        Collections.sort(operations, new Comparator<Operation>() {
            @Override
            public int compare(Operation o1, Operation o2) {
                return o1.getName().compareTo(o2.getName());
            }
        });
    }

    public QName getQName() {
        return qname;
    }

    public String getNamespace() {
        return namespace;
    }

    public String getName() {
        return name;
    }

    public List<Operation> getOperations() {
        return operations;
    }
}
