package be.selckin.ws.util.java2php.php;

import com.google.common.base.Preconditions;

import javax.xml.namespace.QName;

public abstract class PhpType {
    private final QName qName;
    private final String namespace;
    private final String name;

    protected PhpType(QName qName, String namespace, String name) {
        this.qName = Preconditions.checkNotNull(qName);
        this.namespace = Preconditions.checkNotNull(namespace);
        this.name = Preconditions.checkNotNull(name);
    }

    public QName getQName() {
        return qName;
    }

    public String getNamespace() {
        return namespace;
    }

    public String getName() {
        return name;
    }

    public String getAbsolutePhpName() {
        return "\\" + namespace + "\\" + name;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        PhpType phpType = (PhpType) o;

        if (!name.equals(phpType.name)) return false;
        if (!namespace.equals(phpType.namespace)) return false;

        return true;
    }

    @Override
    public int hashCode() {
        int result = namespace.hashCode();
        result = 31 * result + name.hashCode();
        return result;
    }

    @Override
    public String toString() {
        return "PhpType{" +
                "name='" + name + '\'' +
                '}';
    }
}
